final: prev:

let
  pySmartDL = prev.callPackage ./development/python/pySmartDL {};
  cfscrape = prev.callPackage ./development/python/cfscrape {};
  discord-system-electron = prev.callPackage ./applications/networking/instant-messengers/discord {
    # Wayland
    # NOTE: electron under Wayland has no window titlebars
    upstreamElectron = prev.electron_16;
    extraStartupArgs = "--enable-features=UseOzonePlatform --ozone-platform=wayland";
    #extraStartupArgs = "--enable-features=UseOzonePlatform --ozone-platform=wayland --enable-features=WebRTCPipeWireCapturer";
  };
in {
  inherit discord-system-electron;

  input-remapper = prev.callPackage ./tools/games/input-remapper {};
  vfio-isolate = prev.callPackage ./tools/virtualisation/vfio-isolate {};
  mopidy-funkwhale = prev.callPackage ./applications/audio/mopidy/funkwhale.nix {};
  python3Packages = prev.python3Packages // {
    pySmartDL = pySmartDL;
    cfscrape = cfscrape;
  };

  replaysorcery = prev.callPackage ./tools/games/replaysorcery {};
  evdev-proxy = prev.callPackage ./tools/virtualisation/evdev-proxy {};
  virtiofsd = prev.callPackage ./tools/virtualisation/virtiofsd {};
  anime4k = prev.callPackage ./misc/video/anime4k {};
  mpv-shader-pack = prev.callPackage ./misc/video/mpv-shader-pack {};
  anime-dl = prev.callPackage ./tools/video/animedl {
    pySmartDL = pySmartDL;
    cfscrape = cfscrape;
  };

  sddm-sugar-dark = prev.callPackage ./sddm-sugar-dark {};
  
  surface-control = prev.callPackage ./tools/system/surface-control {};

  trackma = prev.callPackage ./tools/video/trackma {};
  
  gajim-mainwindow = prev.callPackage ./applications/networking/instant-messengers/gajim {
    nbxmpp = prev.python3Packages.nbxmpp.overrideAttrs (old: {
      src = prev.fetchFromGitLab {
        domain = "dev.gajim.org";
        owner = "gajim";
        repo = "python-nbxmpp";
        rev = "2c74f928f2ff2573b40c7fadc3cc52eaf936e370";
        sha256 = "045qj3q497lrdgjd7j0xwjrhfbnafhs2qk2a308a52fmpg702xm7";
      };
    });
  };
  
  swaync = prev.callPackage ./tools/desktop/swaync {};

  sound-gambit = prev.callPackage tools/audio/sound-gambit {};
  ebu-norm = prev.callPackage tools/audio/ebu-norm {};

  payload-dumper = prev.callPackage tools/system/payload-dumper {};

  psst = prev.callPackage tools/audio/psst {};

  wlrootsqt = prev.libsForQt5.callPackage ./wlrootsqt.nix {};
  qtgreet = prev.libsForQt5.callPackage ./qtgreet.nix {};

  spice-gtk = prev.callPackage temp/spice-gtk/default.nix {};

  discord-app = prev.callPackage applications/networking/instant-messengers/discord-app {
    chromium = prev.ungoogled-chromium;
  };

  zoom-vm = prev.callPackage scripts/zoom-vm {};
}
